# CSC 111: Day 13
# Author: Sara Mathieson and CSC 111 class
# A program to compute the range of a list (in the mathematical sense)
# Makes use of helper functions minimum and maximum

# MONDAY UPDATES:
# 1) start with the min as infinity and the max as -infinity (need this for empty list)
# 2) print statements to show debugging workflow


# compute and return the minimum value of a list
def minimum(lst):
    my_min = float('inf') # start very high and move the min lower and lower

    # way (1) of iterating over a list
    for i in range(len(lst)): # i is the index
        print("Element",lst[i])
        if lst[i] < my_min:
            my_min = lst[i] # update my_min
            print('got to the case where we update min')

    # way (2) of iterating over a list
    '''for l in lst: # l is an element of the list
        if l < my_min:
            my_min = l # reassign my_min'''

    return my_min # here is where we "give back" the value of my_min


# compute and return the maximum value of a list
# we copy and pasted minimum and changed the variable names and < to >
def maximum(lst):
    my_max = -float('inf') # start very low and move the max higher and higher

    for i in range(len(lst)): # i is the index
       print("Element",lst[i])
       if lst[i] > my_max:
           my_max = lst[i]
           print('got to the case where we update max')
           
    return my_max


# using minimum(...) and maximum(...), return the range
def lst_range(lst):
    my_min = minimum(lst) # call helper function
    print()
    my_max = maximum(lst) # call helper function
    print()
    r = my_max - my_min
    return r


# in the main method, test our our functions
def main():

    my_lst = [17, 10, 1, 12, 5, 18, 15, 16, 6, 14]

    # commenting out my testing at the very end
    '''my_min = minimum(my_lst)
    print(my_min)
    my_max = maximum(my_lst)
    print(my_max)'''

    # this is what I really wanted to do all along
    r = lst_range(my_lst)
    print("Range is",r)


main()
